## spades 4.0.0+really3.15.5+dfsg

=== dnanexus/Makefile ===
default:
	PREFIX=`pwd`/resources/usr src/spades_compile.sh

.PHONY: default

=== assembler/ext/src/CMakeLists.txt ===
# -*- cmake -*-

if (SPADES_USE_JEMALLOC)
  add_subdirectory(jemalloc EXCLUDE_FROM_ALL)
endif()
if (SPADES_USE_MIMALLOC)
  add_subdirectory(mimalloc EXCLUDE_FROM_ALL)
endif()
add_subdirectory(nlopt)
add_subdirectory(python_libs/joblib2)
add_subdirectory(python_libs/joblib3)
add_subdirectory(python_libs/pyyaml2)
add_subdirectory(python_libs/pyyaml3)
add_subdirectory(ConsensusCore)
add_subdirectory(bamtools)
add_subdirectory(samtools)
add_subdirectory(cppformat)
add_subdirectory(ssw)
add_subdirectory(getopt_pp)
add_subdirectory(llvm)
add_subdirectory(bwa)
add_subdirectory(gqf)
add_subdirectory(edlib)
add_subdirectory(gfa1)
add_subdirectory(easel)
add_subdirectory(hmmer)
add_subdirectory(googletest)
add_subdirectory(teamcity_gtest)

=== assembler/src/common/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(common_modules CXX)

add_subdirectory(pipeline)
add_subdirectory(sequence)
add_subdirectory(assembly_graph)
add_subdirectory(modules/path_extend)
add_subdirectory(modules)
add_subdirectory(paired_info)
add_subdirectory(stages)
add_subdirectory(utils)
add_subdirectory(io)
add_subdirectory(utils/kmer_mph)
add_subdirectory(modules/coverage_model)
add_subdirectory(hmm)

add_library(common_modules
            adt/concurrent_dsu.cpp)

target_link_libraries(common_modules
                      assembly_graph input pipeline sequence coverage_model paired_info path_extend stages utils mph_index modules)

=== assembler/src/spades_pipeline/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015-2019 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades_pipeline)

# SPAdes pipeline scripts
install(FILES
        run_contig_breaker.py
        commands_parser.py
        process_cfg.py
        support.py
        options_storage.py
        options_parser.py
        DESTINATION share/spades/spades_pipeline
        COMPONENT runtime)

install(DIRECTORY scripts
        DESTINATION share/spades/spades_pipeline/
        COMPONENT runtime
        PATTERN "*.pyc" EXCLUDE)


install(DIRECTORY stages
        DESTINATION share/spades/spades_pipeline/
        COMPONENT runtime
        PATTERN "*.pyc" EXCLUDE)

# TruSpades module
install(DIRECTORY truspades
        DESTINATION share/spades/spades_pipeline/
        COMPONENT runtime
        PATTERN "*.pyc" EXCLUDE)

# Common module
install(DIRECTORY common
        DESTINATION share/spades/spades_pipeline/
        COMPONENT runtime
        PATTERN "*.pyc" EXCLUDE)

# Executors scripts
install(DIRECTORY executors
        DESTINATION share/spades/spades_pipeline/
        COMPONENT runtime
        PATTERN "*.pyc" EXCLUDE)

=== assembler/ext/src/bamtools/CMakeLists.txt ===
# ==========================
# BamTools CMakeLists.txt
# (c) 2010 Derek Barnett
#
# top-level
# ==========================

# set project name
project( BamTools )

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)

# set BamTools version information
set( BamTools_VERSION_MAJOR 2 )
set( BamTools_VERSION_MINOR 3 )
set( BamTools_VERSION_BUILD 0 )

add_definitions( -D_FILE_OFFSET_BITS=64 )

# list subdirectories to build in
add_subdirectory( api )

=== assembler/ext/src/cppformat/CMakeLists.txt ===
project(FORMAT)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)

set(FMT_SOURCES format.cc)

include(CheckSymbolExists)
check_symbol_exists(open fcntl.h HAVE_OPEN)
if (HAVE_OPEN)
  add_definitions(-DFMT_USE_FILE_DESCRIPTORS=1)
  set(FMT_SOURCES ${FMT_SOURCES} posix.cc)
endif ()

add_library(format ${FMT_SOURCES})
set_target_properties(format PROPERTIES COMPILE_FLAGS  "-Wall -Wextra -pedantic")

=== assembler/ext/src/googletest/CMakeLists.txt ===
# Note: CMake support is community-based. The maintainers do not use CMake
# internally.

cmake_minimum_required(VERSION 2.8.8)

if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)

project(googletest-distribution)
set(GOOGLETEST_VERSION 1.10.0)

if (CMAKE_VERSION VERSION_GREATER "3.0.2")
  if(NOT CYGWIN AND NOT MSYS AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL QNX)
    set(CMAKE_CXX_EXTENSIONS OFF)
  endif()
endif()

enable_testing()

include(CMakeDependentOption)
include(GNUInstallDirs)

#Note that googlemock target already builds googletest
option(BUILD_GMOCK "Builds the googlemock subproject" OFF)
option(INSTALL_GTEST "Enable installation of googletest. (Projects embedding googletest may want to turn this OFF.)" OFF)

if(BUILD_GMOCK)
  add_subdirectory( googlemock )
else()
  add_subdirectory( googletest )
endif()

=== assembler/ext/src/llvm/CMakeLists.txt ===
project(llvm-support)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${EXT_DIR}/include)

include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CheckSymbolExists)

check_include_file(execinfo.h  HAVE_EXECINFO_H)
check_include_file(signal.h    HAVE_SIGNAL_H)
check_include_file(sys/stat.h  HAVE_SYS_STAT_H)
check_include_file(cxxabi.h    HAVE_CXXABI_H)
check_include_file(dlfcn.h     HAVE_DLFCN_H)
check_include_file(mach/mach.h HAVE_MACH_MACH_H)
check_include_file(link.h      HAVE_LINK_H)
check_include_file(unistd.h    HAVE_UNISTD_H)
check_include_file(sys/mman.h  HAVE_SYS_MMAN_H)
check_include_file(fcntl.h     HAVE_FCNTL_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)
check_include_file(pthread.h   HAVE_PTHREAD_H)
check_include_file(sys/time.h  HAVE_SYS_TIME_H)
check_include_file(sys/resource.h HAVE_SYS_RESOURCE_H)

find_package(Backtrace)
set(HAVE_BACKTRACE ${Backtrace_FOUND})
set(BACKTRACE_HEADER ${Backtrace_HEADER})

check_symbol_exists(futimens sys/stat.h HAVE_FUTIMENS)
check_symbol_exists(futimes sys/time.h HAVE_FUTIMES)
check_symbol_exists(getrusage sys/resource.h HAVE_GETRUSAGE)
check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
check_symbol_exists(sysconf unistd.h HAVE_SYSCONF)
check_symbol_exists(mallinfo malloc.h HAVE_MALLINFO)
check_symbol_exists(mallctl malloc_np.h HAVE_MALLCTL)
check_symbol_exists(malloc_zone_statistics malloc/malloc.h
                    HAVE_MALLOC_ZONE_STATISTICS)

find_library(DL_LIB NAMES "dl")

check_library_exists(pthread pthread_create "" HAVE_LIBPTHREAD)
if (HAVE_LIBPTHREAD)
  check_library_exists(pthread pthread_getspecific "" HAVE_PTHREAD_GETSPECIFIC)
  check_library_exists(pthread pthread_rwlock_init "" HAVE_PTHREAD_RWLOCK_INIT)
  check_library_exists(pthread pthread_mutex_lock "" HAVE_PTHREAD_MUTEX_LOCK)
else()
  check_library_exists(c pthread_create "" PTHREAD_IN_LIBC)
  if (PTHREAD_IN_LIBC)
    check_library_exists(c pthread_getspecific "" HAVE_PTHREAD_GETSPECIFIC)
    check_library_exists(c pthread_rwlock_init "" HAVE_PTHREAD_RWLOCK_INIT)
    check_library_exists(c pthread_mutex_lock "" HAVE_PTHREAD_MUTEX_LOCK)
  endif()
endif()
check_library_exists(dl dlopen "" HAVE_LIBDL)
check_library_exists(rt clock_gettime "" HAVE_LIBRT)

if(HAVE_LIBPTHREAD)
  # We want to find pthreads library and at the moment we do want to
  # have it reported as '-l<lib>' instead of '-pthread'.
  # TODO: switch to -pthread once the rest of the build system can deal with it.
  set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
  set(THREADS_HAVE_PTHREAD_ARG Off)
  find_package(Threads REQUIRED)
  set(LLVM_PTHREAD_LIB ${CMAKE_THREAD_LIBS_INIT})
endif()

add_definitions(-D__STDC_CONSTANT_MACROS)
add_definitions(-D__STDC_LIMIT_MACROS)

# FIXME: Signal handler return type, currently hardcoded to 'void'
set(RETSIGTYPE void)

configure_file(${EXT_DIR}/include/llvm/Config.h.in
               ${SPADES_BUILT_INCLUDE_DIR}/llvm/Config.h)

file(GLOB sources "[a-zA-Z]*.cpp" "[a-zA-Z]*.c")

add_library(llvm-support STATIC
  ${sources})
if (DL_LIB)
  target_link_libraries(llvm-support ${DL_LIB})
endif()

=== assembler/src/common/io/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(input CXX)

add_subdirectory(binary)

add_library(input STATIC
            reads/parser.cpp
            reads/paired_readers.cpp
            reads/binary_converter.cpp
            reads/binary_streams.cpp
            reads/io_helper.cpp
            dataset_support/read_converter.cpp
            dataset_support/dataset_readers.cpp
            sam/read.cpp
            sam/sam_reader.cpp)

include_directories(SYSTEM "${ZLIB_INCLUDE_DIRS}")
target_link_libraries(input binary_io BamTools samtools ${ZLIB_LIBRARIES})

add_subdirectory(graph)

=== assembler/src/common/utils/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(utils CXX)

set(utils_src
    memory_limit.cpp
    filesystem/copy_file.cpp
    filesystem/path_helper.cpp
    filesystem/temporary.cpp
    filesystem/glob.cpp
    logger/logger_impl.cpp)

if (READLINE_FOUND)
  set(utils_src ${utils_src} autocompletion.cpp)
endif()

add_library(utils STATIC
            ${utils_src})
target_link_libraries(utils ${COMMON_LIBRARIES})

add_library(version STATIC
            version.cpp)

=== assembler/src/projects/cds_subgraphs/CMakeLists.txt ===
############################################################################
# Copyright (c) 2018 Saint Petersburg State University
# Copyright (c) 2019 University of Warwick
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(cds-subgraphs CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})


add_executable(cds-subgraphs
               stop_condon_finder.cpp
               subgraph_extraction.cpp
               main.cpp)

add_executable(cds-mapping-stats
               stats.cpp)

target_link_libraries(cds-subgraphs graphio common_modules ${COMMON_LIBRARIES})
target_link_libraries(cds-mapping-stats graphio common_modules ${COMMON_LIBRARIES})

if (SPADES_STATIC_BUILD)
  set_target_properties(cds-subgraphs PROPERTIES LINK_SEARCH_END_STATIC 1)
  set_target_properties(cds-mapping-stats PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS cds-subgraphs
        DESTINATION bin
        COMPONENT runtime)

install(TARGETS cds-mapping-stats
        DESTINATION bin
        COMPONENT runtime)

=== assembler/src/projects/gmapper/CMakeLists.txt ===
############################################################################
# Copyright (c) 2018 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(gmapper CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

add_executable(spades-gmapper
               main.cpp)

target_link_libraries(spades-gmapper spades-stages graphio common_modules ${COMMON_LIBRARIES})

if (SPADES_STATIC_BUILD)
  set_target_properties(spades-gmapper PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS spades-gmapper
        DESTINATION bin
        COMPONENT runtime)

=== debian/changelog ===
spades (4.0.0+really3.15.5+dfsg-3) unstable; urgency=medium

  * Fix build with CMake 4
    Closes: #1113531
  * d/watch: version=5
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 20 Oct 2025 15:20:24 +0200

spades (4.0.0+really3.15.5+dfsg-2) unstable; urgency=medium

  [ Pierre Gruet ]
  * Adding d/README.source to warn against future uploads of spades 4.x

  [ Nilesh Patra ]
  * Fixup FTBFS with gcc-15 (Closes: #1097913)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 20 Sep 2025 02:36:42 +0530

spades (4.0.0+really3.15.5+dfsg-1) unstable; urgency=medium

  * Team upload
  * New upstream version 4.0.0+really3.15.5+dfsg, reverting to last version in
    testing
  * Reverting patches, d/control, and d/rules from version 3.15.5+dfsg-8
  * Raising Standards version to 4.7.2 (no change)

 -- Pierre Gruet <pgt@debian.org>  Sat, 12 Apr 2025 11:33:01 +0200

spades (4.0.0+dfsg1-2) unstable; urgency=low

  * Remove listed license files (ext/src/hmmer/libdivsufsort/COPYING) from copyright.

 -- Andreas Tille <tille@debian.org>  Sun, 16 Feb 2025 11:28:59 +0100

spades (3.15.5+dfsg-8) unstable; urgency=medium

  * Team upload
  * Fixing Python3 SyntaxWarning by using raw regex patterns (Closes: #1087093)

 -- Pierre Gruet <pgt@debian.org>  Sat, 14 Dec 2024 00:09:08 +0100

=== debian/control ===
Source: spades
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
 Sascha Steinbiss <satta@debian.org>,
 Michael R. Crusoe <crusoe@debian.org>,
 Alexandre Mestiashvili <mestia@debian.org>,
 Étienne Mollier <emollier@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 clang-format,
 clang-tidy,
 clang-tools,
 cmake,
 python3-all,
 zlib1g-dev,
 libbz2-dev,
 libbam-dev,
 libbamtools-dev,
 libc++-dev,
 libhts-dev,
 libnlopt-dev,
 libnlopt-cxx-dev,
 libssw-dev,
 libzstd-dev,
 llvm-dev,
 python3-yaml,
 python3-joblib,
 asciidoctor,
 bwa,
 libbwa-dev,
 lynx,
Vcs-Browser: https://salsa.debian.org/med-team/spades
Vcs-Git: https://salsa.debian.org/med-team/spades.git
Homepage: https://github.com/ablab/spades
Rules-Requires-Root: no

Package: spades
Architecture: amd64
Depends:
 ${shlibs:Depends},
 ${python3:Depends},
 ${misc:Depends},
 python3,
 python3-joblib,
 python3-packaging,
 python3-yaml,
 bwa,
 bamtools,
 samtools,
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.
 .
 This package provides the following additional pipelines:
  * metaSPAdes – a pipeline for metagenomic data sets
  * plasmidSPAdes – a pipeline for extracting and assembling plasmids
    from WGS data sets
  * metaplasmidSPAdes – a pipeline for extracting and assembling
    plasmids from metagenomic data sets
  * rnaSPAdes – a de novo transcriptome assembler from RNA-Seq data
  * truSPAdes – a module for TruSeq barcode assembly
  * biosyntheticSPAdes – a module for biosynthetic gene cluster
    assembly with paired-end reads
 .
 SPAdes provides several stand-alone binaries with relatively simple
 command-line interface: k-mer counting (spades-kmercounter), assembly
 graph construction (spades-gbuilder) and long read to graph aligner
 (spades-gmapper).

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

mandir     := $(CURDIR)/debian/man
debfolder  := $(CURDIR)/debian

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export LC_ALL = C

%:
	dh $@ --sourcedirectory=assembler/src --buildsystem=cmake

override_dh_clean:
	dh_clean -X.orig

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.pyc" -delete
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)

override_dh_auto_configure:
	dh_auto_configure -- -DBoost_NO_BOOST_CMAKE=TRUE -DCMAKE_POLICY_VERSION_MINIMUM=3.5

override_dh_auto_build:
	dh_auto_build -- all debruijn_test include_test

execute_after_dh_auto_install:
	# Use Debian-packaged yaml module
	find debian/spades \
		-type f \
		-exec sed -i 's/pyyaml[2|3]/yaml/' {} +

	mkdir -p debian/$(DEB_SOURCE)/usr/libexec/spades/
	mv debian/$(DEB_SOURCE)/usr/bin/* debian/$(DEB_SOURCE)/usr/libexec/spades/

	rm -f debian/$(DEB_SOURCE)/usr/share/spades/*.html
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/manual.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/GPLv2.txt
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/README.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/LICENSE

override_dh_installman:
	mkdir -p $(mandir)
	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman

override_dh_installchangelogs:
	LANG="C" LANGUAGE="en_US:en" LC_ALL=C.UTF-8 lynx -dump assembler/changelog.html > changelog
	dh_installchangelogs changelog
	rm changelog

=== debian/tests/control ===
Tests: run-unit-test
Depends: @,bwa
Restrictions: allow-stderr

=== debian/watch ===
Version: 5

Template: Github
Owner: ablab
Project: spades
Repack-Suffix: +dfsg
Dversion-Mangle: auto
